/* SPDX-License-Identifier: GPL-2.0 */
/*
 * firmware header
 *
 * Copyright (c) Imagination Technologies Ltd.
 * Copyright (c) 2018 Texas Instruments Incorporated - http://www.ti.com/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation version 2.
 *
 * This program is distributed "as is" WITHOUT ANY WARRANTY of any
 * kind, whether express or implied; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _REGCONV_H_topazhp_coreext_regs_h
#define _REGCONV_H_topazhp_coreext_regs_h

/* Register CR_SCALER_INPUT_SIZE */
#define TOPAZHP_EXT_CR_SCALER_INPUT_SIZE 0x0000
#define MASK_TOPAZHP_EXT_CR_SCALER_INPUT_WIDTH_MIN1 0x00000FFF
#define SHIFT_TOPAZHP_EXT_CR_SCALER_INPUT_WIDTH_MIN1 0
#define REGNUM_TOPAZHP_EXT_CR_SCALER_INPUT_WIDTH_MIN1 0x0000
#define SIGNED_TOPAZHP_EXT_CR_SCALER_INPUT_WIDTH_MIN1 0

#define MASK_TOPAZHP_EXT_CR_SCALER_INPUT_HEIGHT_MIN1 0x0FFF0000
#define SHIFT_TOPAZHP_EXT_CR_SCALER_INPUT_HEIGHT_MIN1 16
#define REGNUM_TOPAZHP_EXT_CR_SCALER_INPUT_HEIGHT_MIN1 0x0000
#define SIGNED_TOPAZHP_EXT_CR_SCALER_INPUT_HEIGHT_MIN1 0

/* Register CR_SCALER_PITCH */
#define TOPAZHP_EXT_CR_SCALER_PITCH 0x0004
#define MASK_TOPAZHP_EXT_CR_SCALER_INPUT_HOR_PITCH 0x00007FFF
#define SHIFT_TOPAZHP_EXT_CR_SCALER_INPUT_HOR_PITCH 0
#define REGNUM_TOPAZHP_EXT_CR_SCALER_INPUT_HOR_PITCH 0x0004
#define SIGNED_TOPAZHP_EXT_CR_SCALER_INPUT_HOR_PITCH 0

#define MASK_TOPAZHP_EXT_CR_SCALER_HOR_BILINEAR_FILTER 0x00008000
#define SHIFT_TOPAZHP_EXT_CR_SCALER_HOR_BILINEAR_FILTER 15
#define REGNUM_TOPAZHP_EXT_CR_SCALER_HOR_BILINEAR_FILTER 0x0004
#define SIGNED_TOPAZHP_EXT_CR_SCALER_HOR_BILINEAR_FILTER 0

#define MASK_TOPAZHP_EXT_CR_SCALER_INPUT_VER_PITCH 0x7FFF0000
#define SHIFT_TOPAZHP_EXT_CR_SCALER_INPUT_VER_PITCH 16
#define REGNUM_TOPAZHP_EXT_CR_SCALER_INPUT_VER_PITCH 0x0004
#define SIGNED_TOPAZHP_EXT_CR_SCALER_INPUT_VER_PITCH 0

#define MASK_TOPAZHP_EXT_CR_SCALER_VER_BILINEAR_FILTER 0x80000000
#define SHIFT_TOPAZHP_EXT_CR_SCALER_VER_BILINEAR_FILTER 31
#define REGNUM_TOPAZHP_EXT_CR_SCALER_VER_BILINEAR_FILTER 0x0004
#define SIGNED_TOPAZHP_EXT_CR_SCALER_VER_BILINEAR_FILTER 0

/* Register CR_SCALER_CROP */
#define TOPAZHP_EXT_CR_SCALER_CROP  0x0008
#define MASK_TOPAZHP_EXT_CR_SCALER_INPUT_CROP_VER 0x000000FF
#define SHIFT_TOPAZHP_EXT_CR_SCALER_INPUT_CROP_VER 0
#define REGNUM_TOPAZHP_EXT_CR_SCALER_INPUT_CROP_VER 0x0008
#define SIGNED_TOPAZHP_EXT_CR_SCALER_INPUT_CROP_VER 0

#define MASK_TOPAZHP_EXT_CR_SCALER_INPUT_CROP_HOR 0x0000FF00
#define SHIFT_TOPAZHP_EXT_CR_SCALER_INPUT_CROP_HOR 8
#define REGNUM_TOPAZHP_EXT_CR_SCALER_INPUT_CROP_HOR 0x0008
#define SIGNED_TOPAZHP_EXT_CR_SCALER_INPUT_CROP_HOR 0

/* Register CR_SCALER_VER_LUMA_COEFFS_0 */
#define TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFFS_0 0x0010
#define MASK_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_00(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_00(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_00(i) 0x0010

/* Register CR_SCALER_VER_LUMA_COEFFS_1 */
#define TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFFS_1 0x0014
#define MASK_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_01(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_01(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_01(i) 0x0014

/* Register CR_SCALER_VER_LUMA_COEFFS_2 */
#define TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFFS_2 0x0018
#define MASK_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_02(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_02(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_02(i) 0x0018

/* Register CR_SCALER_VER_LUMA_COEFFS_3 */
#define TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFFS_3 0x001C
#define MASK_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_03(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_03(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF_03(i) 0x001C

/* Register CR_SCALER_VER_CHROMA_COEFFS_0 */
#define TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFFS_0 0x0020
#define MASK_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_00(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_00(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_00(i) 0x0020

/* Register CR_SCALER_VER_CHROMA_COEFFS_1 */
#define TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFFS_1 0x0024
#define MASK_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_01(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_01(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_01(i) 0x0024

/* Register CR_SCALER_VER_CHROMA_COEFFS_2 */
#define TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFFS_2 0x0028
#define MASK_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_02(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_02(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_02(i) 0x0028

/* Register CR_SCALER_VER_CHROMA_COEFFS_3 */
#define TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFFS_3 0x002C
#define MASK_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_03(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_03(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF_03(i) 0x002C

/* Register CR_SCALER_HOR_LUMA_COEFFS_0 */
#define TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFFS_0 0x0030
#define MASK_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_00(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_00(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_00(i) 0x0030

/* Register CR_SCALER_HOR_LUMA_COEFFS_1 */
#define TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFFS_1 0x0034
#define MASK_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_01(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_01(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_01(i) 0x0034

/* Register CR_SCALER_HOR_LUMA_COEFFS_2 */
#define TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFFS_2 0x0038
#define MASK_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_02(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_02(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_02(i) 0x0038

/* Register CR_SCALER_HOR_LUMA_COEFFS_3 */
#define TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFFS_3 0x003C
#define MASK_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_03(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_03(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF_03(i) 0x003C

/* Register CR_SCALER_HOR_CHROMA_COEFFS_0 */
#define TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFFS_0 0x0040
#define MASK_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_00(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_00(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_00(i) 0x0040

/* Register CR_SCALER_HOR_CHROMA_COEFFS_1 */
#define TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFFS_1 0x0044
#define MASK_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_01(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_01(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_01(i) 0x0044

/* Register CR_SCALER_HOR_CHROMA_COEFFS_2 */
#define TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFFS_2 0x0048
#define MASK_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_02(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_02(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_02(i) 0x0048

/* Register CR_SCALER_HOR_CHROMA_COEFFS_3 */
#define TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFFS_3 0x004C
#define MASK_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_03(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_03(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF_03(i) 0x004C

/* Register CR_SCALER_MEM_BURST_REQ_CRC */
#define TOPAZHP_EXT_CR_SCALER_MEM_BURST_REQ_CRC 0x0050
#define MASK_TOPAZHP_EXT_CR_SCALER_MEM_BURST_REQ_CRC 0xFFFFFFFF
#define SHIFT_TOPAZHP_EXT_CR_SCALER_MEM_BURST_REQ_CRC 0
#define REGNUM_TOPAZHP_EXT_CR_SCALER_MEM_BURST_REQ_CRC 0x0050
#define SIGNED_TOPAZHP_EXT_CR_SCALER_MEM_BURST_REQ_CRC 0

/* Register CR_SCALER_MEM_READ_DATA_CRC */
#define TOPAZHP_EXT_CR_SCALER_MEM_READ_DATA_CRC 0x0054
#define MASK_TOPAZHP_EXT_CR_SCALER_MEM_READ_DATA_CRC 0xFFFFFFFF
#define SHIFT_TOPAZHP_EXT_CR_SCALER_MEM_READ_DATA_CRC 0
#define REGNUM_TOPAZHP_EXT_CR_SCALER_MEM_READ_DATA_CRC 0x0054
#define SIGNED_TOPAZHP_EXT_CR_SCALER_MEM_READ_DATA_CRC 0

/* Register CR_CURRENT_MB_DATA_CRC */
#define TOPAZHP_EXT_CR_CURRENT_MB_DATA_CRC 0x0058
#define MASK_TOPAZHP_EXT_CR_CURRENT_MB_DATA_CRC 0xFFFFFFFF
#define SHIFT_TOPAZHP_EXT_CR_CURRENT_MB_DATA_CRC 0
#define REGNUM_TOPAZHP_EXT_CR_CURRENT_MB_DATA_CRC 0x0058
#define SIGNED_TOPAZHP_EXT_CR_CURRENT_MB_DATA_CRC 0

/* Register CR_HOR_BIFILTER_DATA_CRC */
#define TOPAZHP_EXT_CR_HOR_BIFILTER_DATA_CRC 0x005C
#define MASK_TOPAZHP_EXT_CR_HOR_BIFILTER_DATA_CRC 0xFFFFFFFF
#define SHIFT_TOPAZHP_EXT_CR_HOR_BIFILTER_DATA_CRC 0
#define REGNUM_TOPAZHP_EXT_CR_HOR_BIFILTER_DATA_CRC 0x005C
#define SIGNED_TOPAZHP_EXT_CR_HOR_BIFILTER_DATA_CRC 0

/* Register CR_EXT_TOPAZHP_CRC_CLEAR */
#define TOPAZHP_EXT_CR_EXT_TOPAZHP_CRC_CLEAR 0x0060
#define MASK_TOPAZHP_EXT_CR_SCALER_CRC_CLEAR 0x00000001
#define SHIFT_TOPAZHP_EXT_CR_SCALER_CRC_CLEAR 0
#define REGNUM_TOPAZHP_EXT_CR_SCALER_CRC_CLEAR 0x0060
#define SIGNED_TOPAZHP_EXT_CR_SCALER_CRC_CLEAR 0

/* Register CR_SCALER_CONTROL */
#define TOPAZHP_EXT_CR_SCALER_CONTROL 0x0064
#define MASK_TOPAZHP_EXT_CR_SCALER_ENABLE 0x00000001
#define SHIFT_TOPAZHP_EXT_CR_SCALER_ENABLE 0
#define REGNUM_TOPAZHP_EXT_CR_SCALER_ENABLE 0x0064
#define SIGNED_TOPAZHP_EXT_CR_SCALER_ENABLE 0

#define MASK_TOPAZHP_EXT_CR_ENABLE_COLOUR_SPACE_CONVERSION 0x00000002
#define SHIFT_TOPAZHP_EXT_CR_ENABLE_COLOUR_SPACE_CONVERSION 1
#define REGNUM_TOPAZHP_EXT_CR_ENABLE_COLOUR_SPACE_CONVERSION 0x0064
#define SIGNED_TOPAZHP_EXT_CR_ENABLE_COLOUR_SPACE_CONVERSION 0

/* Register CR_INPUT_SCALER_CONTROL */
#define TOPAZHP_EXT_CR_INPUT_SCALER_CONTROL 0x0068
#define MASK_TOPAZHP_EXT_CR_ENCODE_CHROMA_FORMAT 0x00000003
#define SHIFT_TOPAZHP_EXT_CR_ENCODE_CHROMA_FORMAT 0
#define REGNUM_TOPAZHP_EXT_CR_ENCODE_CHROMA_FORMAT 0x0068
#define SIGNED_TOPAZHP_EXT_CR_ENCODE_CHROMA_FORMAT 0

#define MASK_TOPAZHP_EXT_CR_ENCODE_BIT_DEPTH 0x00000100
#define SHIFT_TOPAZHP_EXT_CR_ENCODE_BIT_DEPTH 8
#define REGNUM_TOPAZHP_EXT_CR_ENCODE_BIT_DEPTH 0x0068
#define SIGNED_TOPAZHP_EXT_CR_ENCODE_BIT_DEPTH 0

#define MASK_TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT 0x007F0000
#define SHIFT_TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT 16
#define REGNUM_TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT 0x0068
#define SIGNED_TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT 0
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444IL4XBCA8		0x0000007E		/* 4:4:4, Any 3 colour space components plus reserved byte (e.g.
 RGB), 8-bit components, packed 32-bit per pixel in a single plane, 8 LSBits not used */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444IL4ABCX8		0x0000007C		/* 4:4:4, Any 3 colour space components plus reserved byte (e.g.
 RGB), 8-bit components, packed 32-bit per pixel in a single plane, 8 MSBits not used */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444IL3ABC10		0x00000075		/* 4:4:4, Any 3 colour space components (e.g. RGB), 10-bit components,
 packed 32-bit per pixel in a single plane */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444IL3RGB565		0x00000070		/* RGB with 5 bits for R, 6 bits for G and 5 bits for B */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444PL12YCBCR16		0x0000006C		/* 4:4:4, Y in 1 plane, CbCr interleaved in 2nd plane, 16-bit
 components (only 10 MSBits used) */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444PL12YCRCB10		0x0000006B		/* 4:4:4, Y in 1 plane, CrCb interleaved in 2nd plane, 10-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444PL12YCRCB8		0x0000006A		/* 4:4:4, Y in 1 plane, CrCb interleaved in 2nd plane, 8-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444PL12YCBCR10		0x00000069		/* 4:4:4, Y in 1 plane, CbCr interleaved in 2nd plane, 10-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444PL12YCBCR8		0x00000068		/* 4:4:4, Y in 1 plane, CbCr interleaved in 2nd plane, 8-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444PL111YCBCR16		0x00000064		/* 4:4:4, Y Cb Cr in 3 separate planes, 16-bit components
 (could also be ABC, but colour space conversion is not supported by input scaler) */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444PL111YCBCR10		0x00000061		/* 4:4:4, Y Cb Cr in 3 separate planes, 10-bit components
 (could also be ABC, but colour space conversion is not supported by input scaler) */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_444PL111YCBCR8		0x00000060		/* 4:4:4, Y Cb Cr in 3 separate planes, 8-bit components
 (could also be ABC, but colour space conversion is not supported by input scaler) */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_422IL3CRYCBY8		0x00000056		/* 4:2:2, CrYCbY interleaved in a single plane, 8-bit components
 */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_422IL3CBYCRY8		0x00000054		/* 4:2:2, CbYCrY interleaved in a single plane, 8-bit components
 */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_422IL3YCRYCB8		0x00000052		/* 4:2:2, YCrYCb interleaved in a single plane, 8-bit components
 */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_422IL3YCBYCR8		0x00000050		/* 4:2:2, YCbYCr interleaved in a single plane, 8-bit components
 */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_422PL12YCBCR16		0x0000004C		/* 4:2:2, Y in 1 plane, CbCr interleaved in 2nd plane, 16-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_422PL12YCRCB10		0x0000004B		/* 4:2:2, Y in 1 plane, CrCb interleaved in 2nd plane, 10-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_422PL12YCRCB8		0x0000004A		/* 4:2:2, Y in 1 plane, CrCb interleaved in 2nd plane, 8-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_422PL12YCBCR10		0x00000049		/* 4:2:2, Y in 1 plane, CbCr interleaved in 2nd plane, 10-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_422PL12YCBCR8		0x00000048		/* 4:2:2, Y in 1 plane, CbCr interleaved in 2nd plane, 8-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_422PL111YCBCR10		0x00000041		/* 4:2:2, Y Cb Cr in 3 separate planes, 10-bit components
 */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_422PL111YCBCR8		0x00000040		/* 4:2:2, Y Cb Cr in 3 separate planes, 8-bit components
 */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_420PL12YCBCR16		0x0000002C		/* 4:2:0, Y in 1 plane, CbCr interleaved in 2nd plane, 16-bit
 components (only 10 MSBits used) */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_420PL12YCRCB10		0x0000002B		/* 4:2:0, Y in 1 plane, CrCb interleaved in 2nd plane, 10-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_420PL12YCRCB8		0x0000002A		/* 4:2:0, Y in 1 plane, CrCb interleaved in 2nd plane, 8-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_420PL12YCBCR10		0x00000029		/* 4:2:0, Y in 1 plane, CbCr interleaved in 2nd plane, 10-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_420PL12YCBCR8		0x00000028		/* 4:2:0, Y in 1 plane, CbCr interleaved in 2nd plane, 8-bit
 components */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_420PL111YCBCR10		0x00000021		/* 4:2:0, Y Cb Cr in 3 separate planes, 10-bit components
 */
#define TOPAZHP_EXT_CR_INPUT_FRAME_STORE_FORMAT_420PL111YCBCR8		0x00000020		/* 4:2:0, Y Cb Cr in 3 separate planes, 8-bit components
 */

/* Register CR_CSC_SOURCE_MOD_Y_0 */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_Y_0 0x006C
#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_00 0x00000003
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_00 0
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_00 0x006C
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_00 0
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_00_MINUS_1_2		0x00000003		/* Subtract 1/2 maximum value from unsigned pixel component */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_00_MINUS_1_16		0x00000002		/* Subtract 1/16th maximum value from unsigned pixel component */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_00_SIGNED		0x00000001		/* Source pixel component is signed */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_00_UNSIGNED		0x00000000		/* Source pixel component is unsigned */

#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_00 0x0FFF0000
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_00 16
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_00 0x006C
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_00 1

/* Register CR_CSC_SOURCE_CB_CR_0 */
#define TOPAZHP_EXT_CR_CSC_SOURCE_CB_CR_0 0x0070
#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_00 0x00000FFF
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_00 0
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_00 0x0070
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_00 1

#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_00 0x0FFF0000
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_00 16
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_00 0x0070
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_00 1

/* Register CR_CSC_SOURCE_MOD_Y_1 */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_Y_1 0x0074
#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_01 0x00000003
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_01 0
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_01 0x0074
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_01 0
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_01_MINUS_1_2		0x00000003		/* Subtract 1/2 maximum value from unsigned pixel component */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_01_MINUS_1_16		0x00000002		/* Subtract 1/16th maximum value from unsigned pixel component */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_01_SIGNED		0x00000001		/* Source pixel component is signed */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_01_UNSIGNED		0x00000000		/* Source pixel component is unsigned */

#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_01 0x0FFF0000
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_01 16
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_01 0x0074
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_01 1

/* Register CR_CSC_SOURCE_CB_CR_1 */
#define TOPAZHP_EXT_CR_CSC_SOURCE_CB_CR_1 0x0078
#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_01 0x00000FFF
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_01 0
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_01 0x0078
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_01 1

#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_01 0x0FFF0000
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_01 16
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_01 0x0078
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_01 1

/* Register CR_CSC_SOURCE_MOD_Y_2 */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_Y_2 0x007C
#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_02 0x00000003
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_02 0
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_02 0x007C
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_MOD_02 0
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_02_MINUS_1_2		0x00000003		/* Subtract 1/2 maximum value from unsigned pixel component */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_02_MINUS_1_16		0x00000002		/* Subtract 1/16th maximum value from unsigned pixel component */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_02_SIGNED		0x00000001		/* Source pixel component is signed */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_02_UNSIGNED		0x00000000		/* Source pixel component is unsigned */

#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_02 0x0FFF0000
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_02 16
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_02 0x007C
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y_02 1

/* Register CR_CSC_SOURCE_CB_CR_2 */
#define TOPAZHP_EXT_CR_CSC_SOURCE_CB_CR_2 0x0080
#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_02 0x00000FFF
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_02 0
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_02 0x0080
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB_02 1

#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_02 0x0FFF0000
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_02 16
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_02 0x0080
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR_02 1

/* Register CR_CSC_OUTPUT_COEFF_0 */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_COEFF_0 0x0084
#define MASK_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP_00 0x000003FF
#define SHIFT_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP_00 0
#define REGNUM_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP_00 0x0084
#define SIGNED_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP_00 0

#define MASK_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP_00 0x03FF0000
#define SHIFT_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP_00 16
#define REGNUM_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP_00 0x0084
#define SIGNED_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP_00 0

#define MASK_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_00 0x30000000
#define SHIFT_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_00 28
#define REGNUM_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_00 0x0084
#define SIGNED_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_00 0
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_00_ADD_1_2		0x00000003		/* Add 1/2 maximum value prior to applying unsigned clamping */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_00_ADD_1_16		0x00000002		/* Add 1/16th maximum value prior to applying unsigned clamping */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_00_SIGNED		0x00000001		/* Reserved */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_00_UNSIGNED		0x00000000		/* Output pixel clamping applied as unsigned */

/* Register CR_CSC_OUTPUT_COEFF_1 */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_COEFF_1 0x0088
#define MASK_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP_01 0x000003FF
#define SHIFT_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP_01 0
#define REGNUM_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP_01 0x0088
#define SIGNED_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP_01 0

#define MASK_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP_01 0x03FF0000
#define SHIFT_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP_01 16
#define REGNUM_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP_01 0x0088
#define SIGNED_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP_01 0

#define MASK_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_01 0x30000000
#define SHIFT_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_01 28
#define REGNUM_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_01 0x0088
#define SIGNED_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_01 0
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_01_ADD_1_2		0x00000003		/* Add 1/2 maximum value prior to applying unsigned clamping */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_01_ADD_1_16		0x00000002		/* Add 1/16th maximum value prior to applying unsigned clamping */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_01_SIGNED		0x00000001		/* Reserved */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_01_UNSIGNED		0x00000000		/* Output pixel clamping applied as unsigned */

/* Register CR_INPUT_SCALER_CRC_CLEAR */
#define TOPAZHP_EXT_CR_INPUT_SCALER_CRC_CLEAR 0x008C
#define MASK_TOPAZHP_EXT_CR_INPUT_SCALER_CRC_CLEAR 0x00000001
#define SHIFT_TOPAZHP_EXT_CR_INPUT_SCALER_CRC_CLEAR 0
#define REGNUM_TOPAZHP_EXT_CR_INPUT_SCALER_CRC_CLEAR 0x008C
#define SIGNED_TOPAZHP_EXT_CR_INPUT_SCALER_CRC_CLEAR 0

/* Register CR_SCALER_CSC_DATA_CRC */
#define TOPAZHP_EXT_CR_SCALER_CSC_DATA_CRC 0x0090
#define MASK_TOPAZHP_EXT_CR_SCALER_CSC_DATA_CRC 0xFFFFFFFF
#define SHIFT_TOPAZHP_EXT_CR_SCALER_CSC_DATA_CRC 0
#define REGNUM_TOPAZHP_EXT_CR_SCALER_CSC_DATA_CRC 0x0090
#define SIGNED_TOPAZHP_EXT_CR_SCALER_CSC_DATA_CRC 0


/* Table CR_SCALER_VER_LUMA_COEFFS */

/* Register CR_SCALER_VER_LUMA_COEFFS */
#define TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFFS(X) (0x0010 + (4 * (X)))
#define MASK_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFF(X,i) (0x0010 + (4 * (X)))

/* Number of entries in table CR_SCALER_VER_LUMA_COEFFS */

#define TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFFS_SIZE_UINT32 4
#define TOPAZHP_EXT_CR_SCALER_VER_LUMA_COEFFS_NUM_ENTRIES 4


/* Table CR_SCALER_VER_CHROMA_COEFFS */

/* Register CR_SCALER_VER_CHROMA_COEFFS */
#define TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFFS(X) (0x0020 + (4 * (X)))
#define MASK_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFF(X,i) (0x0020 + (4 * (X)))

/* Number of entries in table CR_SCALER_VER_CHROMA_COEFFS */

#define TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFFS_SIZE_UINT32 4
#define TOPAZHP_EXT_CR_SCALER_VER_CHROMA_COEFFS_NUM_ENTRIES 4


/* Table CR_SCALER_HOR_LUMA_COEFFS */

/* Register CR_SCALER_HOR_LUMA_COEFFS */
#define TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFFS(X) (0x0030 + (4 * (X)))
#define MASK_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFF(X,i) (0x0030 + (4 * (X)))

/* Number of entries in table CR_SCALER_HOR_LUMA_COEFFS */

#define TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFFS_SIZE_UINT32 4
#define TOPAZHP_EXT_CR_SCALER_HOR_LUMA_COEFFS_NUM_ENTRIES 4


/* Table CR_SCALER_HOR_CHROMA_COEFFS */

/* Register CR_SCALER_HOR_CHROMA_COEFFS */
#define TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFFS(X) (0x0040 + (4 * (X)))
#define MASK_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF(i) (0x000000FF << (0 + ((i) * 8)))
#define SHIFT_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF(i) (0 + ((i) * 8))
#define REGNUM_TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFF(X,i) (0x0040 + (4 * (X)))

/* Number of entries in table CR_SCALER_HOR_CHROMA_COEFFS */

#define TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFFS_SIZE_UINT32 4
#define TOPAZHP_EXT_CR_SCALER_HOR_CHROMA_COEFFS_NUM_ENTRIES 4


/* Table CR_CSC_SOURCE_COEFF_TABLE */

/* Register CR_CSC_SOURCE_MOD_Y */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_Y(X) (0x006C + (8 * (X)))
#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_MOD 0x00000003
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_MOD 0
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_MOD 0x006C
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_MOD 0
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_MINUS_1_2		0x00000003		/* Subtract 1/2 maximum value from unsigned pixel component */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_MINUS_1_16		0x00000002		/* Subtract 1/16th maximum value from unsigned pixel component */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_SIGNED		0x00000001		/* Source pixel component is signed */
#define TOPAZHP_EXT_CR_CSC_SOURCE_MOD_UNSIGNED		0x00000000		/* Source pixel component is unsigned */

#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y 0x0FFF0000
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y 16
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y 0x006C
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_Y 1

/* Register CR_CSC_SOURCE_CB_CR */
#define TOPAZHP_EXT_CR_CSC_SOURCE_CB_CR(X) (0x0070 + (8 * (X)))
#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB 0x00000FFF
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB 0
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB 0x0070
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CB 1

#define MASK_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR 0x0FFF0000
#define SHIFT_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR 16
#define REGNUM_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR 0x0070
#define SIGNED_TOPAZHP_EXT_CR_CSC_SOURCE_SRC_TO_CR 1

/* Number of entries in table CR_CSC_SOURCE_COEFF_TABLE */

#define TOPAZHP_EXT_CR_CSC_SOURCE_COEFF_TABLE_SIZE_UINT32 6
#define TOPAZHP_EXT_CR_CSC_SOURCE_COEFF_TABLE_NUM_ENTRIES 3


/* Table CR_CSC_OUTPUT_COEFF_TABLE */

/* Register CR_CSC_OUTPUT_COEFF */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_COEFF(X) (0x0084 + (4 * (X)))
#define MASK_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP 0x000003FF
#define SHIFT_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP 0
#define REGNUM_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP 0x0084
#define SIGNED_TOPAZHP_EXT_CR_CSC_OUTPUT_MIN_CLIP 0

#define MASK_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP 0x03FF0000
#define SHIFT_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP 16
#define REGNUM_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP 0x0084
#define SIGNED_TOPAZHP_EXT_CR_CSC_OUTPUT_MAX_CLIP 0

#define MASK_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD 0x30000000
#define SHIFT_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD 28
#define REGNUM_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD 0x0084
#define SIGNED_TOPAZHP_EXT_CR_CSC_OUTPUT_MOD 0
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_ADD_1_2		0x00000003		/* Add 1/2 maximum value prior to applying unsigned clamping */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_ADD_1_16		0x00000002		/* Add 1/16th maximum value prior to applying unsigned clamping */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_SIGNED		0x00000001		/* Reserved */
#define TOPAZHP_EXT_CR_CSC_OUTPUT_MOD_UNSIGNED		0x00000000		/* Output pixel clamping applied as unsigned */

/* Number of entries in table CR_CSC_OUTPUT_COEFF_TABLE */

#define TOPAZHP_EXT_CR_CSC_OUTPUT_COEFF_TABLE_SIZE_UINT32 2
#define TOPAZHP_EXT_CR_CSC_OUTPUT_COEFF_TABLE_NUM_ENTRIES 2

/*
	Byte range covering the group TOPAZHP_COREEXT file
*/

#define TOPAZHP_EXT_TOPAZHP_COREEXT_REGISTERS_START		0x00000000
#define TOPAZHP_EXT_TOPAZHP_COREEXT_REGISTERS_END  		0x00000093

/*
	Byte range covering the whole register file
*/

#define TOPAZHP_EXT_REGISTERS_START		0x00000000
#define TOPAZHP_EXT_REGISTERS_END  		0x00000093
#define TOPAZHP_EXT_REG_DEFAULT_TABLE struct {\
			IMG_UINT16 uRegOffset;\
			IMG_UINT32 uRegDefault;\
			IMG_UINT32 uRegMask;\
			bool bReadonly;\
			const char* pszName;\
		} TOPAZHP_EXT_Defaults[] = {\
	{0x0000, 0x00000000, 0x0FFF0FFF, 0, "CR_SCALER_INPUT_SIZE" } ,\
	{0x0004, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_PITCH" } ,\
	{0x0008, 0x00000000, 0x0000FFFF, 0, "CR_SCALER_CROP" } ,\
	{0x0010, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_VER_LUMA_COEFFS_0" } ,\
	{0x0014, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_VER_LUMA_COEFFS_1" } ,\
	{0x0018, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_VER_LUMA_COEFFS_2" } ,\
	{0x001C, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_VER_LUMA_COEFFS_3" } ,\
	{0x0020, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_VER_CHROMA_COEFFS_0" } ,\
	{0x0024, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_VER_CHROMA_COEFFS_1" } ,\
	{0x0028, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_VER_CHROMA_COEFFS_2" } ,\
	{0x002C, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_VER_CHROMA_COEFFS_3" } ,\
	{0x0030, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_HOR_LUMA_COEFFS_0" } ,\
	{0x0034, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_HOR_LUMA_COEFFS_1" } ,\
	{0x0038, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_HOR_LUMA_COEFFS_2" } ,\
	{0x003C, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_HOR_LUMA_COEFFS_3" } ,\
	{0x0040, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_HOR_CHROMA_COEFFS_0" } ,\
	{0x0044, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_HOR_CHROMA_COEFFS_1" } ,\
	{0x0048, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_HOR_CHROMA_COEFFS_2" } ,\
	{0x004C, 0x00000000, 0xFFFFFFFF, 0, "CR_SCALER_HOR_CHROMA_COEFFS_3" } ,\
	{0x0050, 0x00000000, 0xFFFFFFFF, 1, "CR_SCALER_MEM_BURST_REQ_CRC" } ,\
	{0x0054, 0x00000000, 0xFFFFFFFF, 1, "CR_SCALER_MEM_READ_DATA_CRC" } ,\
	{0x0058, 0x00000000, 0xFFFFFFFF, 1, "CR_CURRENT_MB_DATA_CRC" } ,\
	{0x005C, 0x00000000, 0xFFFFFFFF, 1, "CR_HOR_BIFILTER_DATA_CRC" } ,\
	{0x0060, 0x00000000, 0x00000001, 0, "CR_EXT_TOPAZHP_CRC_CLEAR" } ,\
	{0x0064, 0x00000000, 0x00000003, 0, "CR_SCALER_CONTROL" } ,\
	{0x0068, 0x00200000, 0x007F0103, 0, "CR_INPUT_SCALER_CONTROL" } ,\
	{0x006C, 0x00000000, 0x0FFF0003, 0, "CR_CSC_SOURCE_MOD_Y_0" } ,\
	{0x0070, 0x00000000, 0x0FFF0FFF, 0, "CR_CSC_SOURCE_CB_CR_0" } ,\
	{0x0074, 0x00000000, 0x0FFF0003, 0, "CR_CSC_SOURCE_MOD_Y_1" } ,\
	{0x0078, 0x00000000, 0x0FFF0FFF, 0, "CR_CSC_SOURCE_CB_CR_1" } ,\
	{0x007C, 0x00000000, 0x0FFF0003, 0, "CR_CSC_SOURCE_MOD_Y_2" } ,\
	{0x0080, 0x00000000, 0x0FFF0FFF, 0, "CR_CSC_SOURCE_CB_CR_2" } ,\
	{0x0084, 0x03FF0000, 0x33FF03FF, 0, "CR_CSC_OUTPUT_COEFF_0" } ,\
	{0x0088, 0x03FF0000, 0x33FF03FF, 0, "CR_CSC_OUTPUT_COEFF_1" } ,\
	{0x008C, 0x00000000, 0x00000001, 0, "CR_INPUT_SCALER_CRC_CLEAR" } ,\
	{0x0090, 0x00000000, 0xFFFFFFFF, 1, "CR_SCALER_CSC_DATA_CRC" } ,\
{ 0 }}

#define TOPAZHP_EXT_REGS_INIT(uBase) \
	{ \
		int n;\
		TOPAZHP_EXT_REG_DEFAULT_TABLE;\
		for (n = 0; n < sizeof(TOPAZHP_EXT_Defaults)/ sizeof(TOPAZHP_EXT_Defaults[0] ) -1; n++)\
		{\
			RegWriteNoTrap(TOPAZHP_EXT_Defaults[n].uRegOffset + uBase, TOPAZHP_EXT_Defaults[n].uRegDefault); \
		}\
	}
#endif
